-- 
-- Tabellenstruktur fr Tabelle `comments`
-- 

CREATE TABLE `comments` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `domain_id` int(10) unsigned NOT NULL,
  `record_id` int(10) unsigned NOT NULL,
  `user` varchar(100) collate latin1_german1_ci NOT NULL,
  `when` datetime NOT NULL,
  `msg` text collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `domain_id` (`domain_id`,`record_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `comments_removed`
-- 

CREATE TABLE `comments_removed` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `domain_id` int(10) unsigned NOT NULL,
  `record_id` int(10) unsigned NOT NULL,
  `user` varchar(100) collate latin1_german1_ci NOT NULL,
  `when` datetime NOT NULL,
  `msg` text collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `domain_id` (`domain_id`,`record_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `domains_removed`
-- 

CREATE TABLE `domains_removed` (
  `id` int(11) NOT NULL auto_increment,
  `name` varchar(255) character set latin1 NOT NULL,
  `master` varchar(20) character set latin1 default NULL,
  `last_check` int(11) default NULL,
  `type` varchar(6) character set latin1 NOT NULL,
  `notified_serial` int(11) default NULL,
  `account` varchar(40) character set latin1 default NULL,
  PRIMARY KEY  (`id`),
  UNIQUE KEY `name_index` (`name`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `history`
-- 

CREATE TABLE `history` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `when` datetime NOT NULL,
  `user` varchar(100) collate latin1_german1_ci NOT NULL,
  `action` varchar(20) collate latin1_german1_ci NOT NULL,
  `object` varchar(255) collate latin1_german1_ci NOT NULL,
  `data` text collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=MyISAM  DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `records_removed`
-- 

CREATE TABLE `records_removed` (
  `id` int(11) NOT NULL auto_increment,
  `domain_id` int(11) default NULL,
  `name` varchar(255) character set latin1 default NULL,
  `type` varchar(6) character set latin1 default NULL,
  `content` varchar(255) character set latin1 default NULL,
  `ttl` int(11) default NULL,
  `prio` int(11) default NULL,
  `change_date` int(11) default NULL,
  PRIMARY KEY  (`id`),
  KEY `rec_name_index` (`name`),
  KEY `nametype_index` (`name`,`type`),
  KEY `domain_id` (`domain_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `templates`
-- 

CREATE TABLE `templates` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `name` varchar(50) collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- --------------------------------------------------------

-- 
-- Tabellenstruktur fr Tabelle `tpl_records`
-- 

CREATE TABLE `tpl_records` (
  `id` int(10) unsigned NOT NULL auto_increment,
  `template_id` int(10) unsigned NOT NULL,
  `name` varchar(255) collate latin1_german1_ci NOT NULL,
  `type` varchar(6) collate latin1_german1_ci NOT NULL,
  `prio` tinyint(4) NOT NULL default '0',
  `content` varchar(255) collate latin1_german1_ci NOT NULL,
  `ttl` int(10) unsigned default NULL,
  PRIMARY KEY  (`id`),
  KEY `template_id` (`template_id`)
) ENGINE=InnoDB DEFAULT CHARSET=latin1 COLLATE=latin1_german1_ci ;

-- 
-- Constraints der exportierten Tabellen
-- 

-- 
-- Constraints der Tabelle `records_removed`
-- 
ALTER TABLE `records_removed`
  ADD CONSTRAINT `records_removed_ibfk_1` FOREIGN KEY (`domain_id`) REFERENCES `domains_removed` (`id`) ON DELETE CASCADE;

-- 
-- Constraints der Tabelle `tpl_records`
-- 
ALTER TABLE `tpl_records`
  ADD CONSTRAINT `tpl_records_ibfk_1` FOREIGN KEY (`template_id`) REFERENCES `templates` (`id`) ON DELETE CASCADE;

