<?php
/**
 * @package ZoneAdmin
 * @author Rudolph Bott
 * @version 0.1
 * @copyright Rudolph Bott
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 */


/*
 * PLEASE DONT EDIT THIS FILE
 * IT CONTAINS ONLY DEFAULT VALUES
 * WHICH CAN BE OVERRIDDEN BY
 * THE FILE config.php
 */

error_reporting(E_ALL);

$mysqlcfg["host"] = "localhost";
$mysqlcfg["user"] = "";
$mysqlcfg["pass"] = "";
$mysqlcfg["db"] = "";

$mysqlcfg["domtbl"] = "domains";
$mysqlcfg["rectbl"] = "records";

$mysqlcfg["tpltbl"] = "templates"; 
$mysqlcfg["tplrectbl"] = "tpl_records";
$mysqlcfg["histbl"] = "history";
$mysqlcfg["cmttbl"] = "comments";

$mysqlcfg["remdomtbl"] = "domains_removed";
$mysqlcfg["remrectbl"] = "records_removed";
$mysqlcfg["remcmttbl"] = "comments_removed";

$cfg["basedir"] = dirname(dirname(__FILE__))."/";
$cfg["domain"] = "";
$cfg["reldir"] = "/";

$cfg["maxperpage"] = 50;

$cfg["showversion"] = true;

$cfg["theme"] = "Boxes";
$cfg["lang"] = "en";
$cfg["user"] = "Anonymous"; 

$cfg["striporigin"] = true; 
$cfg["defaultttl"] = 3600;

$cfg["record_types"] = array(
  'A',
  'CNAME',
  'MX',
  'NS',
  'SOA',
  'TXT',
  'PTR',
  'AAAA');


//server-side validation patterns (preg_match() expressions)
if($cfg["striporigin"]) {
  $validate_patterns['SOA']['name_regex'] = '/^$/';
}
else {
  $validate_patterns['SOA']['name_regex'] = '/^[a-z0-9\.-]+$/i';
}
$validate_patterns['SOA']['content_regex'] = '/^[a-z0-9\.\-]+ [a-z0-9\.\-]+ [0-9]+ [0-9]+ [0-9]+ [0-9]+ [0-9]+$/i';
$validate_patterns['SOA']['ttl_regex'] = '/^\d+$/';
$validate_patterns['SOA']['prio_regex'] = '/^0$/';

$validate_patterns['A']['name_regex'] = '/^(\*[\.]{0,1}){0,1}[a-z0-9\.-]*$/i';
$validate_patterns['A']['content_regex'] = '/^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/i';
$validate_patterns['A']['ttl_regex'] = '/^\d+$/';
$validate_patterns['A']['prio_regex'] = '/^0$/';

$validate_patterns['NS']['name_regex'] = '/^[a-z0-9\.-]*$/i';
$validate_patterns['NS']['content_regex'] = '/^[a-z0-9\.-]+$/i';
$validate_patterns['NS']['ttl_regex'] = '/^\d+$/';
$validate_patterns['NS']['prio_regex'] = '/^0$/';

$validate_patterns['MX']['name_regex'] = '/^[a-z0-9\.-]*$/i';
$validate_patterns['MX']['content_regex'] = '/^[a-z0-9\.-]+$/i';
$validate_patterns['MX']['ttl_regex'] = '/^\d+$/';
$validate_patterns['MX']['prio_regex'] = '/^\d+$/';

$validate_patterns['TXT']['name_regex'] = '/^(([a-z0-9\.-]*)|((_domainkey)[a-z0-9\.-]*)|([a-z0-9\.-]+(\._domainkey)[a-z0-9\.-]*))$/i';
$validate_patterns['TXT']['content_regex'] = '/^.+$/i';
$validate_patterns['TXT']['ttl_regex'] = '/^\d+$/';
$validate_patterns['TXT']['prio_regex'] = '/^0$/';

$validate_patterns['PTR']['name_regex'] = '/^[a-z0-9\.-]*$/i';
$validate_patterns['PTR']['content_regex'] = '/^[a-z0-9\.-]+$/i';
$validate_patterns['PTR']['ttl_regex'] = '/^\d+$/';
$validate_patterns['PTR']['prio_regex'] = '/^0$/';

$validate_patterns['CNAME']['name_regex'] = '/^[a-z0-9\.-]*$/i';
$validate_patterns['CNAME']['content_regex'] = '/^[a-z0-9\.-]+$/i';
$validate_patterns['CNAME']['ttl_regex'] = '/^\d+$/';
$validate_patterns['CNAME']['prio_regex'] = '/^0$/';

$validate_patterns['AAAA']['name_regex'] = '/^(\*[\.]{0,1}){0,1}[a-z0-9\.-]*$/i';
$validate_patterns['AAAA']['content_regex'] = '/^[a-fA-F0-9\:]+$/i';
$validate_patterns['AAAA']['ttl_regex'] = '/^\d+$/';
$validate_patterns['AAAA']['prio_regex'] = '/^0$/';

$_errors = array();

define('ZAVERSION','0.1-stable');

require($cfg["basedir"].'includes/definitions.errors.php');
require($cfg["basedir"].'includes/functions.errors.php');
require($cfg["basedir"].'includes/functions.general.php');
require($cfg["basedir"].'includes/functions.history.php');
require($cfg["basedir"].'includes/functions.records.php');
require($cfg["basedir"].'includes/functions.zones.php');
require($cfg["basedir"].'includes/functions.templates.php');
require($cfg["basedir"].'includes/functions.comments.php');
?>
