<?php
/**
 * Provides functions to work with the history-feature
 *
 * $Id: functions.history.php 166 2007-04-16 08:33:54Z rbott $
 *
 * @package ZoneAdmin
 * @author Rudolph Bott
 * @version 0.1
 * @copyright Rudolph Bott
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 */


//nuetzliche funktionen fuer die history

/**
 * adds a history entry
 *
 * the function saves
 * @param string $user currently logged in user
 * @param string $action defines the type of this entry
 * @param string $object the object (e.g. domain) this entry relates to
 * @param string $data serialized data of records/zones that might be used to restore information
 * @return integer primary key of mysql insert operation
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function add_history($user,$action,$object,$data = "") {
  global $mysqlcfg;

  if(!empty($action) && !empty($object)) {
    $query = "INSERT INTO ".$mysqlcfg["histbl"]." (`user`,`when`,`action`,`object`,`data`) VALUES('".mysql_real_escape_string($user)."',NOW(),'".mysql_real_escape_string($action)."','".mysql_real_escape_string($object)."','".mysql_real_escape_string(serialize($data))."')";
    mysql_query($query);
    return mysql_insert_id();
  }
  else {
    return 0;
  }
}

/**
 * retrieves all history information for a given object (e.g. a domain)
 *
 * @param string $object the object
 * @return array 2-dimensional array with database rows
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function get_history_by_object($object) {
  global $mysqlcfg;
  $history = array();

  if(!empty($object)) {
    $query = "SELECT `user`,`when`,`action`,`object`,`data` FROM ".$mysqlcfg["histbl"]." WHERE `object`='".mysql_real_escape_string($object)."' ORDER BY `when` DESC";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $row["data"] = unserialize($row["data"]);
      $history[] = $row;
    }
    mysql_free_result($result);
    return $history;
  }
}

/**
 * retrieves all history information
 *
 * this function fetches all history information
 * sorted by date (descending)
 * @param integer $limit fetch records from here
 * @return array 2-dimensional array with database rows
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function get_history($limit = 0) {
  global $mysqlcfg;
  global $cfg;
  $history = array();

  $query = "SELECT `user`,`when`,`action`,`object`,`data` FROM ".$mysqlcfg["histbl"]." ORDER BY `when` DESC LIMIT ".$limit.",".$cfg["maxperpage"];
  $result = mysql_query($query);
  while($row = mysql_fetch_assoc($result)) {
    $row["data"] = unserialize($row["data"]);
    $history[] = $row;
  }
  mysql_free_result($result);
  return $history;
}

/**
 * formats the data-part of a history entry
 *
 * this function takes the data-part of a history record
 * as input and formats it suitable for output as a comment etc.
 * @param array data of history record
 * @return string formatted string
 * @author Rudolph Bott
 * @copyright Copyright 2007, Rudolph Bott
 * @version V1.0
*/
function format_history_data($data) {
  $pretty = "";
  if(is_array($data) && count($data) > 0) {
    foreach($data AS $record) {
      $pretty .= "Record: ".$record["name"]."  IN  ".$record["type"]."  ".$record["content"]."\n";
    }
  }

  return $pretty;
}
?>
