<?php
/**
 * the Project's main file
 *
 * $Id: index.php 211 2007-07-20 11:28:02Z rbott $
 *
 * @package ZoneAdmin
 * @author Rudolph Bott
 * @version 0.1
 * @copyright Rudolph Bott
 * @license http://www.gnu.org/licenses/gpl.html GNU General Public License
 */

// vim:tabstop=2:expandtab:shiftwidth=2:filetype=php:syntax:ruler:

require('./includes/smarty/libs/Smarty.class.php');
require('./includes/defaults.php');
require('./includes/config.php');

/* temporaerer theme wechsel */
if(isset($_COOKIE["theme"])) $cfg["theme"] = $_COOKIE["theme"];
if(isset($_GET["theme"])) {
  setcookie("theme",$_GET["theme"],time()+60*60*24*30);
  $cfg["theme"] = $_GET["theme"];
}
/* ende temp. theme wechsel */

/* temporaerer theme wechsel */
if(isset($_COOKIE["lang"])) $cfg["lang"] = $_COOKIE["lang"];
if(isset($_GET["lang"]) && strlen($_GET["lang"]) == 2) {
  setcookie("lang",$_GET["lang"],time()+60*60*24*30);
  $cfg["lang"] = $_GET["lang"];
}
/* ende temp. language wechsel */

if(!empty($_SERVER["REMOTE_USER"])) $cfg["user"] = $_SERVER["REMOTE_USER"];


$tpl = new Smarty;

//smarty plugins laden (im moment nur eine substr() funktion)
$tpl->plugins_dir[] = "./includes/smarty_plugins";

//language basis file laden
$tpl->config_load(getcwd().'/lang/lang_en.conf','en');

if(($cfg["lang"] != "en") && file_exists(getcwd().'/lang/lang_'.$cfg["lang"].'.conf')) {
  $tpl->config_load(getcwd().'/lang/lang_'.$cfg["lang"].'.conf',$cfg["lang"]);
}

//default verzeichnis fuer alle templates setzen
$pwd = getcwd().'/tpl/'.$cfg["theme"].'/';

//praktische variable fuer die templates
$tpl->assign('SELF',$_SERVER["PHP_SELF"]);
$tpl->assign('DOMAIN',$cfg["domain"]);
$tpl->assign('RELDIR',$cfg["reldir"]);
$tpl->assign('USER',$cfg["user"]);
$tpl->assign('LANG',$cfg["lang"]);
$tpl->assign('PWD',$pwd);

if($cfg["showversion"]) {
  $tpl->assign('VERSION',ZAVERSION);
}


//check if any errors have beend passed through a location-redirect
if(isset($_GET['errors'])) {
  if(strpos($_GET['errors'],'~') !== false) {
    $strings = explode('~',$_GET['errors']);
  }
  else {
    $strings[] = $_GET['errors'];
  }

  foreach($strings AS $string) {
    if(preg_match('/^[0-9]+%[a-z0-9_-]*%[a-z0-9]*/i',$string)) {
      list($error,$function,$extra) = explode('%',$string);
      if($function == "") {
        $function = "unknown";
      }
      add_error($error,$function,$extra);
    }
  }
}


//wurde section nicht uebergeben, setzen wir es halt
if(isset($_GET["section"])) $section = $_GET["section"];
else $section = "";

switch($section) {
  case 'templates':
    $_content = 'templates.tpl';
    $_pagetitle = '&Uuml;bersicht Zonen-Templates';

    //alle templates holen
    $templates = get_templates();

    for($i = 0;$i < count($templates);$i++) {
      $query = "SELECT COUNT(id) AS cnt FROM ".$mysqlcfg["tplrectbl"]." WHERE template_id='".$templates[$i]["id"]."'";
      $count_result = mysql_query($query);
      $count_row  = mysql_fetch_assoc($count_result);
      $templates[$i]["count"] = $count_row["cnt"];
      mysql_free_result($count_result);
    }

    $tpl->assign('templates',$templates);

    $tpl->assign('side_menu_title',translate('all_templates'));

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=addtpl";
    $menu[count($menu)-1]["title"] = translate('new_template');

    $tpl->assign('side_menu',$menu);

  break;
  case 'showtpl':
    $_content = 'showtemplate.tpl';
    $_pagetitle = 'Template anzeigen';

    $template = get_template_from_id($_GET["template"]);
    $tpl->assign('template_name',$template);
    $tpl->assign('template_id',$_GET["template"]);

    $records = get_template_records($_GET["template"]);
    $tpl->assign('records',$records);

    $tpl->assign('side_menu_title',$template);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showtpl&template=".$_GET["template"];
    $menu[count($menu)-1]["title"] = translate("template_overview");
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=addtplrec&template=".$_GET["template"];
    $menu[count($menu)-1]["title"] = translate("add_record");
    $menu[]["link"] = "javascript:if (checkDelete('".$template."')) location.href='".$cfg["domain"].$cfg["reldir"]."actions.php?action=deltpl&template=".$_GET["template"]."';";
    $menu[count($menu)-1]["title"] = translate("del_template");


    $tpl->assign('side_menu',$menu);
 
  break;
  case 'addtpl':
    $_content = 'addtpl.tpl';
    $_pagetitle = 'neues Template anlegen';

    $tpl->assign('side_menu_title',translate('new_template'));
  
  break;
  case 'addtplrec':
    $_content = 'addtplrecord.tpl';
    $_pagetitle = 'Record zu Template hinzuf&uuml;gen';

    $template = get_template_from_id($_GET["template"]);
    $tpl->assign('template_name',$template);
    $tpl->assign('template_id',$_GET["template"]);
    $tpl->assign('default_ttl',$cfg["defaultttl"]);
    $tpl->assign('record_types',$cfg["record_types"]);

    $tpl->assign('side_menu_title',$template);
  
    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showtpl&template=".$_GET["template"];
    $menu[count($menu)-1]["title"] = translate("template_overview");

    if(!empty($_GET["addanother"])) {
      $tpl->assign('AddAnother','true');
    }
  
    $tpl->assign('side_menu',$menu);
  break;
  case 'edittplrec':
    $_content = 'edittplrecord.tpl';
    $_pagetitle = 'Template-Record bearbeiten';

    $tpl->assign('record_types',$cfg["record_types"]);

    $cur_template = get_template_from_id($_GET["template"]);
    $cur_record = get_template_record($_GET["record"]);

    $tpl->assign('record_types',$cfg["record_types"]);

    $tpl->assign('current_template',$cur_template);
    $tpl->assign('current_template_id',$_GET["template"]);

    $tpl->assign('current_record',$cur_record['name']);
    $tpl->assign('current_record_id',$cur_record['id']);

    $tpl->assign('content',$cur_record['content']);
    $tpl->assign('prio',$cur_record['prio']);
    $tpl->assign('ttl',$cur_record['ttl']);
    $tpl->assign('type',$cur_record['type']);

    $tpl->assign('side_menu_title',translate("edit_record"));

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showtpl&template=".$_GET["template"];
    $menu[count($menu)-1]["title"] = translate("template_overview");

    $tpl->assign('side_menu',$menu);

  break; 
  case 'history':
    $_content = 'history.tpl';
    $_pagetitle = 'History anzeigen';

    $menu = array();

    //wurde page-variable uebergeben? wenn ja, dann startposition fuer die datenbank ausrechnen
    if(isset($_GET["page"]) && is_numeric($_GET["page"]) && $_GET["page"] > 0) {
      $start = $cfg["maxperpage"] * ($_GET["page"] - 1);
      $page = $_GET["page"];
    }
    else {
      $start = 0;
      $page = 1;
    }

    $tpl->assign('page',$page);

    //wieviele Seiten gibt es?
    $query = "SELECT COUNT(*) FROM ".$mysqlcfg["histbl"];
    $count = mysql_fetch_row(mysql_query($query));

    $pages = floor($count[0] / $cfg["maxperpage"]);

    $tpl->assign('pages',$pages);

    if($pages > 10) {
      if($page > 7) {
        $pages_start = $page - 5;
        $pages_end = $page + 4;
        if($pages_end > $pages) $pages_end = $pages;
      }
      else {
        $pages_start = 1;
        $pages_end = 10;
      }

      $tpl->assign("pages_start",$pages_start);
      $tpl->assign("pages_end",$pages_end);
    }
    

    //wollen wir history fuer ein bestimmtes objekt oder alle eintraege?
    if(isset($_GET["object"])) {
      $history = get_history_by_object($_GET["object"]);
      $menu[]["link"] = $cfg["domain"].$cfg["reldir"]."index.php?section=history";
      $menu[count($menu)-1]["title"] = translate("all_objects");
    }
    else {
      $history = get_history($start);
    }

    for($i = 0;$i < count($history);$i++) {
      if($history[$i]["action"] == "DEL ZONE") {
        if(!domain_exists($history[$i]["object"]) == 0) $history[$i]["undo"] = "true";
        else $history[$i]["undo"] = "false";
      }
      else if ($history[$i]["action"] == "DEL RECORD") {
        if(domain_exists($history[$i]["object"])) $history[$i]["undo"] = true;
        else $history[$i]["undo"] = "true";
      }
      else {
        $history[$i]["undo"] = "false";
      }
      $history[$i]["data"] = format_history_data($history[$i]["data"]);
    }

    $tpl->assign('history',$history);

    $tpl->assign('side_menu_title',translate('show_history'));
    $tpl->assign('side_menu',$menu);

  break;
  case 'zonesearch':
    $_content = 'zones.tpl';
    $_pagetitle = 'Suchergebnisse';

    //alle domains holen, die dem suchstring entsprechen
    $query = "SELECT id,name FROM ".$mysqlcfg["domtbl"]." WHERE name LIKE '%".mysql_real_escape_string($_GET["q"])."%' ORDER by name";
    $result = mysql_query($query);
    $domains = array();
    while($row = mysql_fetch_assoc($result)) {
      $domains[] = $row;
    }
    mysql_free_result($result);

    $tpl->assign('zones',$domains);
    $tpl->assign('zones_count',count($domains));

    //das menue zusammenbasteln
    $tpl->assign('side_menu_title',translate('search_results'));
     
  break;
  case 'recsearch':
    $_content = 'recsearch.tpl';
    $_pagetitle = 'Suchergebnisse';

    $query = "SELECT * FROM ".$mysqlcfg["rectbl"]." WHERE content LIKE '%".mysql_real_escape_string($_GET["q"])."%' OR name LIKE '%".addslashes($_GET["q"])."%'";
    $result = mysql_query($query);
    $records = array();
    while($row = mysql_fetch_assoc($result)) {
      $records[] = $row;
    }
    mysql_free_result($result);

    $tpl->assign('records',$records);
    $tpl->assign('search_query',$_GET["q"]);
    $tpl->assign('search_query_count',count($records));
    $tpl->assign('side_menu_title',translate('search_results'));

  break;
  case 'zones':
    $_content = 'zones.tpl';
    $_pagetitle = 'Alle Zonen';

    // aktive domains holen
    $query = "SELECT id,name FROM ".$mysqlcfg["domtbl"]." ORDER by name";
    $result = mysql_query($query);
    $domains = array();
    while($row = mysql_fetch_assoc($result)) {
      $domains[] = $row;
    }
    mysql_free_result($result);
    $tpl->assign('zones',$domains);
    $tpl->assign('zones_count',count($domains));

    $letters = array();
    foreach($domains AS $domain) {
      $first = strtoupper(substr($domain["name"],0,1));
      if(!in_array($first,$letters)) {
        $letters[] = $first;
      }
    }

    $tpl->assign('letters',$letters);

    //das menue zusammenbasteln:
    $tpl->assign('side_menu_title',translate('all_zones'));

    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=addzone";
    $menu[count($menu)-1]["title"] = translate("add_new_zone");

    $tpl->assign('side_menu',$menu);

  break;
  case 'disabledzones':
    $_content = 'disabled_zones.tpl';
    $_pagetitle = 'Inaktive Zonen';

    //inaktive domains holen
    $query = "SELECT id,name FROM ".$mysqlcfg["remdomtbl"]." ORDER by name";
    $result = mysql_query($query);
    $domains = array();
    while($row = mysql_fetch_assoc($result)) {
      $domains[] = $row;
    }
    mysql_free_result($result);
    $tpl->assign('zones',$domains);
    $tpl->assign('zones_count',count($domains));


    //das menue zusammenbasteln:
    $tpl->assign('side_menu_title',translate('disabled_zones'));

/*    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=zones";
    $menu[count($menu)-1]["title"] = translate("show_all_zones");
 
    $tpl->assign('side_menu',$menu);*/

  break;
  case 'showzone':
    $_content = 'showzone.tpl';
    $_pagetitle = 'Zonen&uuml;bersicht';

    //alle eintraege zur uebergebenen domain-id holen
    $records = get_domain_records($_GET["zone"]);
    $tpl->assign('records',$records);

    //fetch domain type (SLAVE, NATIVE, MASTER)
    $type = get_domain_type($_GET["zone"]);
    $tpl->assign('type',$type);

    //den namen zu uebergebenen domain-id holen
    $cur_zone = get_domain_from_id($_GET["zone"]);

    // sind wir in einer Reverse-Zone, wird brauchbar sortiert
    // (nach zahlen/ip-adressen und nicht nach strings)!
    if(substr($cur_zone,-13) == ".in-addr.arpa") {
      $records = sort_reverse_zone_array($records);
      $tpl->assign('records',$records);
    }

    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);

    //letzte aenderung der domain holen
    $last_change = last_change_domain($_GET["zone"]);
    if($last_change == "") {
      $last_change = "n/a";
    }
    $tpl->assign('last_change',$last_change);

    //kommentar zur domain holen
    $comment = get_comment($_GET["zone"],0);
    $tpl->assign('zone_comment',$comment["msg"]);

    $history = get_history_by_object($cur_zone);
    
    for($i = 0;$i < count($history);$i++) {
      if($history[$i]["action"] == "DEL ZONE") {
        if(get_id_from_domain($history[$i]["object"]) == 0) $history[$i]["undo"] = "true";
        else $history[$i]["undo"] = "false";
      }
      else if ($history[$i]["action"] == "DEL RECORD") {
        if(get_id_from_domain($history[$i]["object"]) > 0) $history[$i]["undo"] = true;
        else $history[$i]["undo"] = "true";
      }
      else {
        $history[$i]["undo"] = "false";
      }
      $history[$i]["data"] = format_history_data($history[$i]["data"]);
    }

    $tpl->assign('history',$history);
    $tpl->assign('history_count',count($history));

    //irgendwelche fehler auszugeben?
    
    $error_msg = "";

    if(isset($_GET["ser_error"])) {
      $error_msg .= translate("bad_serial")."<br />\n";
    }

    if(isset($_GET["ref_error"])) {
      $error_msg .= translate("ref_error")."<br />\n";

      $saveorigin = $cfg['striporigin'];
      $cfg['striporigin'] = false;
      $host = get_domain_record($_GET['record']);
      $cfg['striporigin'] = $saveorigin;

      $refs = get_host_references($host['name']);

      foreach($refs AS $ref) {
        $error_msg .= $ref["name"]."<br />\n";
      }
    }

    if(strlen($error_msg) > 0) {
      $tpl->assign('error_msg',$error_msg);
    }

    //das menue zusammenbasteln:
    $tpl->assign('side_menu_title',$cur_zone);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    if($type != "SLAVE") {
      $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=addrec&zone=".$_GET["zone"];
      $menu[count($menu)-1]["title"] = translate("add_record");

      $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=editsoa&zone=".$_GET["zone"];
      $menu[count($menu)-1]["title"] = translate("edit_soa");
    }

    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=zonedump&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zonedump");

    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=sqldump&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("sqldump");

    $menu[]["link"] = "actions.php?action=disablezone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("disable_zone");

    $menu[]["link"] = "javascript:if (checkDelete('".$cur_zone."')) location.href='".$cfg["domain"].$cfg["reldir"]."actions.php?action=delzone&zone=".$_GET["zone"]."';";
    $menu[count($menu)-1]["title"] = translate("del_zone");

    $tpl->assign('side_menu',$menu);

  break;
  case 'addrec':
    $_content = 'addrecord.tpl';
    $_pagetitle = 'Neuen Record anlegen';

    //den namen der uebergebenen domain-id holen
    $cur_zone = get_domain_from_id($_GET["zone"]);
    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);
    $tpl->assign('default_ttl',$cfg["defaultttl"]);
    $tpl->assign('record_types',$cfg["record_types"]);

    //das menue zusammenbasteln:
    $tpl->assign('side_menu_title',$cur_zone);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    if(!empty($_GET["addanother"])) {
      $tpl->assign('AddAnother','true');
    }

    $tpl->assign('side_menu',$menu);  
  break;
  case 'editrec':
    $_content = 'editrecord.tpl';
    $_pagetitle = 'Record bearbeiten';

    $tpl->assign('record_types',$cfg["record_types"]);

    $cur_zone = get_domain_from_id($_GET["zone"]);
    $cur_record = get_domain_record($_GET["record"]);

    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);

    $tpl->assign('current_record',$cur_record['name']);
    $tpl->assign('current_record_id',$cur_record['id']);

    $tpl->assign('content',$cur_record['content']);
    $tpl->assign('prio',$cur_record['prio']);
    $tpl->assign('ttl',$cur_record['ttl']);
    $tpl->assign('type',$cur_record['type']);
    $tpl->assign('comment',$cur_record['comment']);

    $tpl->assign('side_menu_title',translate("edit_record"));

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    $tpl->assign('side_menu',$menu);

  break;
  case 'editsoa':
    $_content = 'editsoa.tpl';
    $_pagetitle = 'SOA Record bearbeiten';

    $cur_zone = get_domain_from_id($_GET["zone"]);
    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);
    $tpl->assign('default_ttl',$cfg["defaultttl"]);

    $soa = parse_soa($_GET["zone"]);

    $tpl->assign('master',$soa["master"]);
    $tpl->assign('contact',$soa["contact"]);
    $tpl->assign('serial',$soa["serial"]);
    $tpl->assign('refresh',$soa["refresh"]);
    $tpl->assign('retry',$soa["retry"]);
    $tpl->assign('expire',$soa["expire"]);
    $tpl->assign('ttl',$soa["ttl"]);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    $tpl->assign('side_menu',$menu);
    $tpl->assign('side_menu_title',$cur_zone);

  break;
  case 'zonedump':
    $_content = 'zonedump.tpl';
    $_pagetitle = 'Zone als Zonefile dumpen';

    $cur_zone = get_domain_from_id($_GET["zone"]);
    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);

    $zonedump = dump_to_zonefile($_GET["zone"]);
    $tpl->assign('zonedump',$zonedump);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=zonedumpDL&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zonedump_dl");

    $tpl->assign('side_menu',$menu);
    $tpl->assign('side_menu_title',$cur_zone);
    break;
  case 'zonedumpDL':
    $zonedump = dump_to_zonefile($_GET["zone"]);
    $cur_zone = get_domain_from_id($_GET["zone"]);
    header('Content-type: text/plain');
    header('Content-Disposition: attachment; filename="'.$cur_zone.'"');
    echo $zonedump;
    exit;
  break;
  case 'sqldump':
    $_content = 'sqldump.tpl';
    $_pagetitle = 'Zone als SQL Dump ausgeben';

    $cur_zone = get_domain_from_id($_GET["zone"]); 
    $tpl->assign('current_zone',$cur_zone);
    $tpl->assign('current_zone_id',$_GET["zone"]);

    $sqldump = dump_to_sql($_GET["zone"]);
    $tpl->assign('sqldump',$sqldump);

    $menu = array();
    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=showzone&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("zone_overview");

    $menu[]["link"] = $_SERVER["PHP_SELF"]."?section=sqldumpDL&zone=".$_GET["zone"];
    $menu[count($menu)-1]["title"] = translate("sqldump_dl");

    $tpl->assign('side_menu',$menu);
    $tpl->assign('side_menu_title',$cur_zone);     
  break;
  case 'sqldumpDL':
    $zonedump = dump_to_sql($_GET["zone"]);
    $cur_zone = get_domain_from_id($_GET["zone"]);
    header('Content-type: text/plain');
    header('Content-Disposition: attachment; filename="'.$cur_zone.'.sql"');
    echo $zonedump;
    exit;
  break;
  case 'addzone':
    $_content = 'addzone.tpl';
    $_pagetitle = 'Neue Zone anlegen';

    $templates = get_templates();

    $tpl->assign('templates',$templates);

    $tpl->assign('side_menu_title',translate("add_new_zone"));

  break;
  case 'statistics':
    $_content = 'statistics.tpl';
    $_pagetitle = "Statistiken";

    //anzahl aktiver domains
    $query = "SELECT COUNT(*) AS count FROM ".$mysqlcfg["domtbl"];
    $result = mysql_query($query);
    $row = mysql_fetch_assoc($result);
    $active_domains_count = $row["count"];
    mysql_free_result($result);

    //anzahl aktiver records
    $query = "SELECT COUNT(*) AS count FROM ".$mysqlcfg["rectbl"];
    $result = mysql_query($query);
    $row = mysql_fetch_assoc($result);
    $active_records_count = $row["count"];
    mysql_free_result($result);

    //anzahl inaktiver domains
    $query = "SELECT COUNT(*) AS count FROM ".$mysqlcfg["remdomtbl"];
    $result = mysql_query($query);
    $row = mysql_fetch_assoc($result);
    $inactive_domains_count = $row["count"];
    mysql_free_result($result);

    //anzahl inaktiver records
    $query = "SELECT COUNT(*) AS count FROM ".$mysqlcfg["remrectbl"];
    $result = mysql_query($query);
    $row = mysql_fetch_assoc($result);
    $inactive_records_count = $row["count"];
    mysql_free_result($result);

    //verteilung der tlds
    $tlds = array();
    $query = "SELECT SUBSTRING_INDEX(name,'.',-1) AS tld, COUNT(*) AS count FROM ".$mysqlcfg["domtbl"]." GROUP BY tld ORDER BY count DESC";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $tlds[] = $row;
    }
    mysql_free_result($result);

    //aktivste domains
    $active_domains = array();
    $query = "SELECT object,count(*) AS count FROM ".$mysqlcfg["histbl"]." GROUP BY object ORDER BY count DESC LIMIT 10";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $active_domains[] = $row;
    }
    mysql_free_result($result);

    //aktivste user
    $active_users = array();
    $query = "SELECT user,count(*) AS count FROM ".$mysqlcfg["histbl"]." GROUP BY user ORDER BY count DESC LIMIT 5";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $active_users[] = $row;
    }
    mysql_free_result($result);

    //haeufigste vorgaenge
    $active_actions = array();
    $query = "SELECT action,count(*) AS count FROM ".$mysqlcfg["histbl"]." GROUP BY action ORDER BY count DESC LIMIT 5";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $active_actions[] = $row;
    }
    mysql_free_result($result);

    //zuletzt geaenderte domains
    $last_changed_domains = array();
    $query = "SELECT d.name, substring_index(substring_index(content,' ',3),' ',-1) AS serial FROM ".$mysqlcfg["rectbl"]." r LEFT JOIN domains d ON (r.domain_id = d.id) WHERE r.type='SOA' ORDER BY serial DESC  LIMIT 5";
    $result = mysql_query($query);
    while($row = mysql_fetch_assoc($result)) {
      $last_changed_domains[] = $row;
    }
    mysql_free_result($result);

    $tpl->assign('active_domains_count',$active_domains_count);
    $tpl->assign('active_records_count',$active_records_count);
    $tpl->assign('inactive_domains_count',$inactive_domains_count);
    $tpl->assign('inactive_records_count',$inactive_records_count);
    $tpl->assign('tlds',$tlds);
    $tpl->assign('active_domains',$active_domains);
    $tpl->assign('active_users',$active_users);
    $tpl->assign('active_actions',$active_actions);
    $tpl->assign('last_changed_domains',$last_changed_domains);

  break;
  case 'settings':

    $_content = "settings.tpl";
    $_pagetitle = "Einstellungen";

    //list available themes
    $tpls = array();
    if ($handle = opendir('./tpl')) {
      while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != ".." && is_dir('./tpl/'.$file) && file_exists('./tpl/'.$file.'/page.tpl')) {
          $tpls[] = $file;
        }
      }
      closedir($handle);
    }
    $tpl->assign('templates',$tpls);


    //list available languages
    $lang = array();
    if ($handle = opendir('./lang')) {
      while (false !== ($file = readdir($handle))) {
        if ($file != "." && $file != ".." && preg_match("/^lang_([a-z]{2})\.conf$/",$file,$hit)) {
          $lang[] = $hit[1];
        }
      }
      closedir($handle);
    }
    $tpl->assign('languages',$lang);

  break;
  default:

    //default-seite anzeigen
    
    $tpl->assign('side_menu_title',translate('home'));
    $_content = 'home.tpl';
    $_pagetitle = '';

}

//what content template is page.tpl supposed to include?
$tpl->assign('_content',$pwd.$_content);

//set pagetitle
$tpl->assign("pagetitle",$_pagetitle);

//prepare errors (if any) for output in template
if(count($_errors) > 0) {

  //translate all error codes to the corresponding
  //localized error string
  for($i = 0;$i < count($_errors);$i++) {
    $_errors[$i]['error'] = translate_error($_errors[$i]['error']);
  }

  $tpl->assign('error_msgs',$_errors);
  $errors = $tpl->fetch($pwd.'errors.tpl');
  $tpl->assign('errors',$errors);
}

//let smarty display everything
$tpl->display($pwd.'page.tpl');
?>
